define('ExternalPayment.Model.Extension'
,  [
      'ExternalPayment.Model'
    , 'underscore'
]
,  function (
      ExternalPaymentModel
      , _
   )
{
  'use strict';

    _.extend(ExternalPaymentModel.prototype,
    {
      _isDone: function (request, record_type)
      {
        var status = this._getStatusFromRequest(request, record_type)
        ,  status_accept_value = this._getConfiguration(record_type, 'statusAcceptValue','ACCEPT')
        ,  status_hold_value = this._getConfiguration(record_type, 'statusHoldValue', 'HOLD')
        
        //Added by payment
        ,  status_pending_value = this._getConfiguration(record_type, 'statusPendingValue', 'PENDING')
        return status === status_accept_value || status === status_hold_value || status === status_pending_value;
      }
    
      , _validateRecordStatus: function (record)
      {
        //Modified by Payment
        return record.getFieldValue('paymenteventholdreason') === 'FORWARD_REQUESTED';
      }

      , _validateStatusFromRequest: function (request, record_type)
      {
        var status = this._getStatusFromRequest(request, record_type)
        ,  status_accept_value = this._getConfiguration(record_type, 'statusAcceptValue' , 'ACCEPT')
        ,  status_hold_value = this._getConfiguration(record_type, 'statusHoldValue' , 'HOLD')

        //Added by Payment
        ,  status_pending_value = this._getConfiguration(record_type, 'statusPendingValue', 'PENDING')
        ,  status_reject_value = this._getConfiguration(record_type, 'statusRejectValue' , 'REJECT');

        //Modified by Payment
        return status === status_accept_value || status === status_pending_value || status === status_hold_value || status === status_reject_value;
      }
    });
});